module ShapePicture_Editor exposing (main)
--Browser
import Browser
import Browser.Navigation as Nav
-- Url
import Url
-- Own
import TypeHolder exposing (Model, Msg(..))
import Manager.UpdateManager exposing (update)
import Manager.ViewManager   exposing (documentView)
import Manager.StateManager  as StM
import Util.Util exposing (Picture, isEdit)

main = Browser.application
        { init = init
        , subscriptions = subscriptions
        , update = update
        , view = documentView
        , onUrlChange = UrlChanged
        , onUrlRequest = LinkClicked
        }
-- INIT
init : () -> Url.Url -> Nav.Key-> (Model, Cmd Msg)
init _ url key =
    ( { state = StM.Standby
      , saved = []
      , svgShapeHover = 0
      , shapesLoadResult = (Ok " Init")
      , picture = { url= ( Url.Url
                              Url.Http
                              "www.informatik.uni-halle.de"
                              Nothing
                              "/im/1285058520_1381_00_800.jpg"
                              Nothing
                              Nothing
                           )
                  , w = 0
                  , h = 0
                  }
      , edit = (isEdit url)
      , url  = url
      , key  = key
      , errorString = ""
      , stringToShapes = "[{\"shape\": {\"circle\": {\"cx\": \"589\",\"cy\": \"108\",\"r\": \"79\"}},\"shapeprop\": {\"hFC\": \"white\",\"hFO\": \"0.5\", \"hSC\": \"red\", \"hSW\": \"3\", \"hSO\": \"1.0\", \"uFC\": \"white\",\"uFO\": \"0.0\", \"uSC\": \"red\", \"uSW\": \"3\", \"uSO\": \"1.0\", \"title\": \"default\", \"body\": \"default\" }},   { \"shape\": { \"rect\": { \"x\": \"265\", \"y\": \"64\", \"width\": \"64\", \"height\": \"54\" } }, \"shapeprop\": { \"hFC\": \"white\", \"hFO\": \"0.5\", \"hSC\": \"red\", \"hSW\": \"3\", \"hSO\": \"1.0\", \"uFC\": \"white\", \"uFO\": \"0.0\", \"uSC\": \"red\", \"uSW\": \"3\", \"uSO\": \"1.0\", \"title\": \"default\", \"body\": \"default\" } }, { \"shape\": { \"ellipse\": { \"cx\": \"380\", \"cy\": \"296\", \"rx\": \"68\", \"ry\": \"61\" } }, \"shapeprop\": { \"hFC\": \"white\", \"hFO\": \"0.5\", \"hSC\": \"red\", \"hSW\": \"3\", \"hSO\": \"1.0\", \"uFC\": \"white\", \"uFO\": \"0.0\", \"uSC\": \"red\", \"uSW\": \"3\", \"uSO\": \"1.0\", \"title\": \"default\", \"body\": \"default\" } }, { \"shape\": { \"polygon\": [ { \"x\": \"269\", \"y\": \"150\" }, { \"x\": \"301\", \"y\": \"192\" }, { \"x\": \"365\", \"y\": \"216\" }, { \"x\": \"265\", \"y\": \"220\" } ] }, \"shapeprop\": { \"hFC\": \"white\", \"hFO\": \"0.5\", \"hSC\": \"red\", \"hSW\": \"3\", \"hSO\": \"1.0\", \"uFC\": \"white\", \"uFO\": \"0.0\", \"uSC\": \"red\", \"uSW\": \"3\", \"uSO\": \"1.0\", \"title\": \"default\", \"body\": \"default\" } } ]"
      }
    , Cmd.none
    )
-- SUBSCRIPTIONS
subscriptions : Model -> Sub Msg
subscriptions model = Sub.none