module TypeHolder exposing (Model, Msg(..))
-- Http
import Http
-- Browser
import Browser
import Browser.Navigation as Nav
-- Url
import Url
-- Own
import Manager.StateManager exposing (State)
import Manager.ModalManager exposing (Modal, ModalMsg)
import Util.ShapeManager exposing (Shape, ShapeStyle, ShapesMsg)
import Util.Util         exposing (MousePosition, Picture, ImgDimensions)

type alias Model =
  { state : State
  , saved : List (Shape, ShapeStyle)
  , svgShapeHover : Int
  , shapesLoadResult : (Result Http.Error String)
  , picture : Picture
  , edit: Bool
  , url : Url.Url
  , key : Nav.Key
  , errorString : String
  , stringToShapes : String
  }
type Msg
  -- Manage Objects
  = ManageModal  ModalMsg  String
  | ManageShapes ShapesMsg String
  -- svg
  | SvgShapeHover Int
  -- for drawing shapes
  | OpenDrawShape Shape
  | UpdateMousePos MousePosition
  | InputDrawShape
  -- for loading shapes with http
  | LoadShapes   (Result Http.Error String)
  | ShapesLoaded (Result Http.Error (List Shape))
  -- Url
  | LinkClicked Browser.UrlRequest
  | UrlChanged Url.Url
  | GotJson String
  -- for saving pictureUrl
  | SavePicture Picture
  | ImgLoaded ImgDimensions